Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# osgUtil::StateGraph Class Reference

StateGraph - contained in a renderBin, defines the scene to be drawn. More...

Inheritance diagram for osgUtil::StateGraph:

[legend]
List of all members.

## Public Types
typedef std::map< const osg::StateSet *, osg::ref_ptr< StateGraph > > | ChildList
typedef std::vector< osg::ref_ptr< RenderLeaf > > | LeafList
## Public Member Functions
| StateGraph ()
| StateGraph (StateGraph *parent, const osg::StateSet *stateset)
| ~StateGraph ()
StateGraph * | cloneType () const
void | setUserData (osg::Referenced *obj)
osg::Referenced * | getUserData ()
const osg::Referenced * | getUserData () const
bool | empty () const
| return true if all of drawables, lights and children are empty.
bool | leaves_empty () const
float | getAverageDistance () const
float | getMinimumDistance () const
void | sortFrontToBack ()
void | reset ()
| Reset the internal contents of a StateGraph, including deleting all children.
void | clean ()
| Recursively clean the StateGraph of all its drawables, lights and depths.
void | prune ()
| Recursively prune the StateGraph of empty children.
StateGraph * | find_or_insert (const osg::StateSet *stateset)
void | addLeaf (RenderLeaf *leaf)
| add a render leaf.
## Static Public Member Functions
void | moveStateGraph (osg::State &state, StateGraph *sg_curr, StateGraph *sg_new)
void | moveToRootStateGraph (osg::State &state, StateGraph *sg_curr)
## Public Attributes
StateGraph * | _parent
const osg::StateSet * | _stateset
int | _depth
ChildList | _children
LeafList | _leaves
float | _averageDistance
float | _minimumDistance
osg::ref_ptr< osg::Referenced > | _userData

## Detailed Description

StateGraph - contained in a renderBin, defines the scene to be drawn.

## Member Typedef Documentation

typedef std::map< const osg::StateSet*, osg::ref_ptr<StateGraph> > osgUtil::StateGraph::ChildList

typedef std::vector< osg::ref_ptr<RenderLeaf> > osgUtil::StateGraph::LeafList

## Constructor & Destructor Documentation

osgUtil::StateGraph::StateGraph | ( |  | ) | `[inline]`

osgUtil::StateGraph::StateGraph | ( | StateGraph * | parent,
|  | const osg::StateSet * | stateset
| ) | `[inline]`

osgUtil::StateGraph::~StateGraph | ( |  | ) | `[inline]`

## Member Function Documentation

void osgUtil::StateGraph::addLeaf | ( | RenderLeaf * | leaf | ) | `[inline]`

| add a render leaf.

void osgUtil::StateGraph::clean | ( |  | ) |

| Recursively clean the StateGraph of all its drawables, lights and depths. Leaves children intact, and ready to be populated again.

StateGraph* osgUtil::StateGraph::cloneType | ( |  | ) | const`[inline]`

bool osgUtil::StateGraph::empty | ( |  | ) | const`[inline]`

| return true if all of drawables, lights and children are empty.

StateGraph* osgUtil::StateGraph::find_or_insert | ( | const osg::StateSet * | stateset | ) | `[inline]`

float osgUtil::StateGraph::getAverageDistance | ( |  | ) | const`[inline]`

float osgUtil::StateGraph::getMinimumDistance | ( |  | ) | const`[inline]`

const osg::Referenced* osgUtil::StateGraph::getUserData | ( |  | ) | const`[inline]`

osg::Referenced* osgUtil::StateGraph::getUserData | ( |  | ) | `[inline]`

bool osgUtil::StateGraph::leaves_empty | ( |  | ) | const`[inline]`

void osgUtil::StateGraph::moveStateGraph | ( | osg::State & | state,
|  | StateGraph * | sg_curr,
|  | StateGraph * | sg_new
| ) | `[inline, static]`

void osgUtil::StateGraph::moveToRootStateGraph | ( | osg::State & | state,
|  | StateGraph * | sg_curr
| ) | `[inline, static]`

void osgUtil::StateGraph::prune | ( |  | ) |

| Recursively prune the StateGraph of empty children.

void osgUtil::StateGraph::reset | ( |  | ) |

| Reset the internal contents of a StateGraph, including deleting all children.

void osgUtil::StateGraph::setUserData | ( | osg::Referenced * | obj | ) | `[inline]`

void osgUtil::StateGraph::sortFrontToBack | ( |  | ) | `[inline]`

## Member Data Documentation

float osgUtil::StateGraph::_averageDistance`[mutable]`

ChildList osgUtil::StateGraph::_children

int osgUtil::StateGraph::_depth

LeafList osgUtil::StateGraph::_leaves

float osgUtil::StateGraph::_minimumDistance`[mutable]`

StateGraph* osgUtil::StateGraph::_parent

const osg::StateSet* osgUtil::StateGraph::_stateset

osg::ref_ptr<osg::Referenced> osgUtil::StateGraph::_userData

The documentation for this class was generated from the following file:

- StateGraph